package com.alibaba.edas.carshop.itemcenter.config;

import com.alibaba.edas.configcenter.config.ConfigChangeListener;
import com.alibaba.edas.configcenter.config.ConfigService;
import org.springframework.beans.factory.InitializingBean;

/**
 * 详细介绍请参照官方文档:https://help.aliyun.com/document_detail/52773.html?spm=a2c4g.11186623.2.4.13mnat
 * 以下代码仅做展示示例。
 */
public class ConfigCenter implements InitializingBean {
    // 属性/开关
    private static String config = "";
    //初始化的时候，给配置添加监听
    private static void initConfig() {
        ConfigService.addListener("diamondTest", "diamondTest",
            new ConfigChangeListener() {
                public void receiveConfigInfo(String configInfo) {
                    try {
                        //当配置更新后，马上获取新的配置
                        config = configInfo;
                        System.out.println(configInfo);
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            });
    }

    // 通过 get 接口把配置值暴露出去使用
    public static String getConfig() {
        return config;
    }

    @Override
    public void afterPropertiesSet() throws Exception {
        initConfig();
    }
}
