package com.alibaba.edas.carshop.itemcenter.filter;

import com.taobao.eagleeye.EagleEye;
import com.taobao.hsf.invocation.Invocation;
import com.taobao.hsf.invocation.InvocationHandler;
import com.taobao.hsf.invocation.RPCResult;
import com.taobao.hsf.invocation.filter.ServerFilter;
import com.taobao.hsf.util.PojoUtils;
import com.taobao.hsf.util.concurrent.ListenableFuture;

public class HSFServerFilter implements ServerFilter {
    @Override
    public ListenableFuture<RPCResult> invoke(InvocationHandler invocationHandler, Invocation invocation) throws Throwable {
        //获取调用链traceId;
        String traceId = EagleEye.getTraceId();
        String[]  sigs = invocation.getMethodArgSigs();
        Object [] args = invocation.getMethodArgs();
        System.out.println("#### intercept request");
        for(String sig : sigs) {
            System.out.print(sig);
        }
        System.out.println();
        for(Object arg : args) {
            System.out.println(PojoUtils.generalize(arg));
        }
        System.out.println();
        return invocationHandler.invoke(invocation);
    }

    @Override
    public void onResponse(Invocation invocation, RPCResult rpcResult) {
        System.out.println("#### intercept response");
        Object resp = rpcResult.getAppResponse();
        System.out.println(PojoUtils.generalize(resp));
    }
}
